

package firma2;
import java.io.*;
import java.security.*;
import java.security.spec.*;


/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author SalvatoreMarano
 * @version 1.0
 */

public class FirmaDocumento {

  public FirmaDocumento( File prk , File f ) {

  /* generiamo un' impronta di messaggio usando DSA alg*/



        System.out.println(" ok ");
		try {



			 /* legge il file che contiene  chiave privata codificata 
			 lo decodifica */

			 FileInputStream keyfis = new FileInputStream(prk);
			 byte[] encKey = new byte[keyfis.available()];
			 keyfis.read(encKey);

			 keyfis.close();

			 /* decodifichiamo la chiave privata*/


			 PKCS8EncodedKeySpec privKeySpec = new PKCS8EncodedKeySpec(encKey);
			 KeyFactory keyFactory = KeyFactory.getInstance("DSA", "SUN");
			 PrivateKey privKey = keyFactory.generatePrivate(privKeySpec);




       /* firma del documento passato nel file */
       Signature dsa = Signature.getInstance("SHA1withDSA", "SUN");

       /* inizializziamo la firma usando la chiave privata */
       dsa.initSign(privKey);

       /* firma del documento contenuto in un file */

			FileInputStream fis = new FileInputStream(f);
 			BufferedInputStream bufin = new BufferedInputStream(fis);
			byte[] buffer = new byte[1024];
			int len;
			while (bufin.available() != 0) {
			len = bufin.read(buffer);
			dsa.update(buffer, 0, len);
			};
			bufin.close();


			byte[] realSig = dsa.sign(); // firma del file

			/* salviamo la firma ottenuta in un file*/

			System.out.println(" ci sono");
			FileOutputStream sigfos = new FileOutputStream("Firma");
			sigfos.write(realSig);
			sigfos.close();



        } catch (Exception e) {
            System.err.println("Caught exception " + e.toString());
        }
    }//costruttore



  }// FirmaDocumento
