package firma2;
import javax.swing.JTabbedPane;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.*;
import java.io.*;

import java.awt.*;
import java.awt.event.*;

public class TabbedPaneDemo extends JPanel {

         static File docFile=null; // file che contiene il documento da firmare
         static File doc1File=null;
         static File keyPrivFile=null;
         static File keyPubFile=null;
         static File signFile=null;
         static private final String newline = "\n";




        static JButton signButton =null;
        static JButton searchButton = null;
        static JButton firma = null;

        static JButton verificaButton =null;
        static JButton search=null;
        static JButton searchSignButton=null;
        static JButton startVerifica =null;

    public TabbedPaneDemo() {


        ImageIcon icon = new ImageIcon("images/middle.gif");
        JTabbedPane tabbedPane = new JTabbedPane();


        Component panel1 = makeFirstPanel();
        tabbedPane.addTab("Firma Digitale",icon, panel1," firma documento" );
        tabbedPane.setSelectedIndex(0);

        Component panel2 = makeSecondPanel();
        tabbedPane.addTab("Verifica Della Firma", icon, panel2, "verifica della firma");


        //Add the tabbed pane to this panel.
        setLayout(new GridLayout(1, 1));
        add(tabbedPane);
    }

    protected Component makeFirstPanel() {

        final  JFileChooser fc = new JFileChooser();


      // definiamo il container della prima selezione
        JPanel panel = new JPanel(new BorderLayout());

        final JTextArea log = new JTextArea(5,20);
        log.setMargin(new Insets(5,5,5,5));
        log.setEditable(false);
        JScrollPane logScrollPane = new JScrollPane(log);


        // costruzione del tastierino
        JPanel buttonPanel= new JPanel();
               signButton = new JButton("Documento da firmare");;
               searchButton = new JButton("Cerca la chiave");
               firma = new JButton("Firma il documento");

        signButton .setEnabled(true);
        searchButton.setEnabled(false);
        firma.setEnabled(false);




        signButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int returnVal = fc.showOpenDialog(TabbedPaneDemo.this);

                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    File documento = fc.getSelectedFile();
                    TabbedPaneDemo.docFile=documento;
                    //this is where a real application would open the file.
                    log.append("Documento da firmare : " + documento.getName() + "." + newline);
                    TabbedPaneDemo.searchButton.setEnabled(true);
                    TabbedPaneDemo.signButton.setEnabled(false);
                } else {
                    log.append("Open command cancelled by user." + newline);
                }
            }


        });



       searchButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int returnVal = fc.showOpenDialog(TabbedPaneDemo.this);

                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    File Key = fc.getSelectedFile();
                    TabbedPaneDemo.keyPrivFile=Key;
                    //this is where a real application would open the file.
                    log.append("Chiave  : " + Key.getName() + "." + newline);
                    TabbedPaneDemo.firma.setEnabled(true);
                    TabbedPaneDemo.searchButton.setEnabled(false);
                } else {
                    log.append("Open command cancelled by user." + newline);
                }
            }
        });





           firma.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {

              FirmaDocumento fd=new FirmaDocumento(TabbedPaneDemo.keyPrivFile,TabbedPaneDemo.docFile);
              TabbedPaneDemo.signButton.setEnabled(true);
              TabbedPaneDemo.firma.setEnabled(false);

              log.append("Il documento Firmato  : " +  TabbedPaneDemo.docFile.getName() + "." + newline);


            }
        });

       buttonPanel.add(signButton);
       buttonPanel.add(searchButton);
       buttonPanel.add(firma);
       panel.add(buttonPanel, BorderLayout.SOUTH);
       panel.add(logScrollPane, BorderLayout.CENTER);
        return panel;
    }

  protected Component makeSecondPanel() {

        //Create a file chooser
         final  JFileChooser fc = new JFileChooser();

        // definiamo il container
        JPanel panel = new JPanel(new BorderLayout());



        final JTextArea log = new JTextArea(5,20);
        log.setMargin(new Insets(5,5,5,5));
        log.setEditable(false);
        JScrollPane logScrollPane = new JScrollPane(log);






        // costruzione del tastierino
        JPanel buttonPanel= new JPanel();

        verificaButton = new JButton("Documento da verificare");
        search = new JButton("Certificato");
        searchSignButton = new JButton("Cerca la Firma");
        startVerifica  = new JButton("Verifica il documento");

        verificaButton.setEnabled(true);
        search.setEnabled(false);
        searchSignButton.setEnabled(false);
        startVerifica.setEnabled(false);


        verificaButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int returnVal = fc.showOpenDialog(TabbedPaneDemo.this);

                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    File documentoF = fc.getSelectedFile();
                    TabbedPaneDemo.doc1File=documentoF;
                    //this is where a real application would open the file.
                    log.append("Documento da verificare : " + documentoF.getName() + "." + newline);
                    TabbedPaneDemo.verificaButton.setEnabled(false);
                    TabbedPaneDemo.search.setEnabled(true);

                } else {
                    log.append("Open command cancelled by user." + newline);
                }
            }
        });


       search.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int returnVal = fc.showOpenDialog(TabbedPaneDemo.this);

                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    File key1 = fc.getSelectedFile();
                    TabbedPaneDemo.keyPubFile=key1;
                    //this is where a real application would open the file.
                    log.append("Chiave  : " + key1.getName() + "." + newline);
                    TabbedPaneDemo.search.setEnabled(false);
                    TabbedPaneDemo.searchSignButton.setEnabled(true);

                } else {
                    log.append("Open command cancelled by user." + newline);
                }
            }
        });


       searchSignButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int returnVal = fc.showOpenDialog(TabbedPaneDemo.this);

                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    File firma = fc.getSelectedFile();
                     TabbedPaneDemo.signFile=firma;
                    //this is where a real application would open the file.
                    log.append("Firma del documento  : " + firma.getName() + "." + newline);
                    TabbedPaneDemo.searchSignButton.setEnabled(false);
                    TabbedPaneDemo.startVerifica.setEnabled(true);
                } else {
                    log.append("Open command cancelled by user." + newline);
                }
            }
        });




        startVerifica.addActionListener(new ActionListener() {
		            public void actionPerformed(ActionEvent e) {
		            VerificaDocumento vd=
		                   new VerificaDocumento(TabbedPaneDemo.keyPubFile  ,  TabbedPaneDemo.signFile,  TabbedPaneDemo.doc1File);
		                   boolean esito= vd.verifica();
                                   if(esito)  log.append(" Ok Il documento  "+ TabbedPaneDemo.doc1File.getName()+ " non ha subito modifiche  : " + newline);
                                   else log.append("ATTENZIONE Il documento "+ TabbedPaneDemo.doc1File.getName()+ "  ha subito modifiche  : " + newline);

                                  TabbedPaneDemo.verificaButton.setEnabled(true);
                                  TabbedPaneDemo.startVerifica.setEnabled(false);

		            }
        });
       buttonPanel.add(verificaButton);
       buttonPanel.add(search);
       buttonPanel.add(searchSignButton);
       buttonPanel.add(startVerifica);
       panel.add(buttonPanel, BorderLayout.SOUTH);
       panel.add(logScrollPane, BorderLayout.CENTER);


        return panel;
    }//secondo pannello
}
