#include <iostream.h>
#include <strstrea.h>
#include "Pila.cpp"

#define DIMENSIONE 100

void main () {
	//istanzio una pila di char
	Pila<char> pila(DIMENSIONE);

	cout << "Inserisci una frase da invertire:\n";
	cout << "(Max " << DIMENSIONE << " caratteri)\n";
	
	//leggo una riga di testo da tastiera
	char* linea = new char(DIMENSIONE);
	cin.getline(linea,DIMENSIONE);
	istrstream is(linea);

	//inserisco ogni char nella pila
	while (!is.eof()) {
		char* c = new char;
		is.read(c,1);
		pila.Push(*c);
	}  
	
	//elimino l'ultimo carattere spurio
	pila.Pop();
	
	//stampo la stringa invertita
	cout << "\nLa frase invertita e':\n";
	while (pila.QuantiElementi()>0)
		cout << pila.Pop();
	cout << "\n\n";	
}