
package firma2;

import java.io.*;
import java.security.*;
import java.security.cert.Certificate;
import java.security.cert.CertificateFactory;
import java.security.spec.*;
/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author SalvatoreMarano
 * @version 1.0
 */

public class VerificaDocumento {


	 byte[] sigToVerify=null;
	 Signature sig=null;
	 File certPbk=null;
	 File firma=null;
	 File f=null;


    public VerificaDocumento( File cert , File firma1, File f1) {

	     certPbk=cert;
             firma=firma1;
	     f=f1;

   }//costruttore


  public boolean  verifica(){

    /* Verify a DSA signature */

      boolean verify=false;

      try {

         /* legge il file che contiene il certificato della chiave pubblica */

          FileInputStream certfis = new FileInputStream( certPbk);

          CertificateFactory cf = CertificateFactory.getInstance("X.509");
          Certificate cert = cf.generateCertificate(certfis);
          certfis.close();
        //stampa informazioni del certificato
          System.out.println(cert);
        // preleviamo la chiave pubblica dal certificato.

        System.out.println("cerco la chiave");
        PublicKey pub = cert.getPublicKey();
        System.out.println("ho trovato la  la chiave");

        /* carichiamo la firma per verificare l'autenticit*/

        FileInputStream sigfis = new FileInputStream(firma);
         sigToVerify = new byte[sigfis.available()];
        sigfis.read(sigToVerify);
        sigfis.close();

        /* procediamo con la verifica creiamo un oggetto firma sul quale
           verifichiamo la chiave pubblica */

        sig = Signature.getInstance("SHA1withDSA", "SUN");
        sig.initVerify(pub);

        /* leggiamo il il file sul quale operare  */

        FileInputStream datafis = new FileInputStream(f);
        BufferedInputStream bufin = new BufferedInputStream(datafis);

        byte[] buffer = new byte[1024];
        int len;
        while (bufin.available() != 0) {
            len = bufin.read(buffer);
            sig.update(buffer, 0, len);
        };

        bufin.close();


      /* verifichiamo la firma*/

     verify = sig.verify(sigToVerify);
     System.out.println("documento modificato : " + verify);



      } catch (Exception e) {
	             System.err.println("Caught exception " + e.toString());
        }



     return verify ;



    }//verifica



}// VerificaDocumento