<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
		<xsl:template match="/">
			<span style="font-family:tahoma;font-size:14pt;">Listino prodotti</span>
			<xsl:apply-templates select="ROOT"/>
		</xsl:template>		
		<xsl:template match="ROOT">
			<table cellspacing="0" cellpadding="4" style="border:1px solid navy">
				<tr style="font-family:tahoma;font-size:8pt;font-weight:bold;background-color:navy;color:#FFFFFF">
					<td nowrap="nowrap">Codice Prodotto</td>
					<td nowrap="nowrap">Descrizione</td>
					<td nowrap="nowrap">Aspetto esteriore</td>
					<td nowrap="nowrap">Prezzo unitario</td>
					<td nowrap="nowrap">Disponibilità</td>
					<td nowrap="nowrap">Riordino</td>
				</tr>			
				<xsl:apply-templates select="Products"/>			
			</table>
		</xsl:template>
		<xsl:template match="Products">
			<tr style="font-family:tahoma;font-size:8pt;">
				<td nowrap="nowrap"><xsl:value-of select="@ProductID"/></td>
				<td nowrap="nowrap"><xsl:value-of select="@ProductName"/></td>
				<td nowrap="nowrap"><xsl:value-of select="@QuantityPerUnit"/></td>
				<td nowrap="nowrap">€ <xsl:value-of select="@UnitPrice"/></td>
				<td nowrap="nowrap"><xsl:value-of select="@UnitsInStock"/></td>
				<td nowrap="nowrap"><xsl:value-of select="@UnitsOnOrder"/></td>
			</tr>			
		</xsl:template>				
</xsl:stylesheet>
