#include "Pila.h"

template<class T>
Pila<T>::Pila(int dim) {
	dimensione =	dim;
	num_elementi = 0;
	vettore_elementi = new T[dimensione];	 
}

template<class T>
Pila<T>::~Pila() {
	delete[] vettore_elementi;
}

template<class T>
void Pila<T>::Push(T elem) {
	if (num_elementi < dimensione) {
		vettore_elementi[num_elementi] = elem;
		num_elementi++;
	}
}

template<class T>
T Pila<T>::Pop() {
	if (num_elementi > 0) {
		num_elementi--;
		return vettore_elementi[num_elementi];
	}
	else
		return T();
}

template<class T>
int Pila<T>::QuantiElementi() {
	return num_elementi;
}

template<class T>
int Pila<T>::Dimensione() {
	return dimensione;
}

