<?xml version='1.0' encoding='UTF-8'?>          
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">    

    <xsl:template match = '*'>                                
        <xsl:apply-templates />                               
    </xsl:template>                                           

    <xsl:template match = 'Products'>                        
       <TR>                                                   
         <TD><xsl:value-of select = '@ProductID' /></TD>      
         <TD><xsl:value-of select = '@ProductName' /></TD>
         <TD><xsl:value-of select = '@UnitsInStock' /></TD>
         <TD><xsl:value-of select = '@UnitsOnOrder' /></TD>        
       </TR>                                                  
    </xsl:template>
    
    <xsl:template match = '/'>                               
      <HTML>                                                  
        <HEAD>                                                
           <STYLE>th { background-color: #CCCCCC }</STYLE>    
        </HEAD>                                               
        <BODY>                                                
         <TABLE border='1' style='width:100%;'>                
           <TR><TH colspan='4'>Catalogo Prodotti per categoria</TH></TR>            
           <TR><TH >Codice Articolo</TH><TH>Descrizione</TH><TH >Giacenza</TH><TH>Unità in riordino</TH></TR>    
           <xsl:apply-templates select = 'ROOT' />            
         </TABLE>                                             
        </BODY>                                               
      </HTML>                                                 
    </xsl:template>                                           
</xsl:stylesheet>

