//*************************************************************************//
//                                                                         //                                                                  //
//          How to Reuse Delphi Components with C++ Applications           //
//          Copyright 2002 Luca Spuntoni                                   //
//          spuntosoft@tiscalinet.it                                       //
//                                                                         //                                                                  //
//*************************************************************************//

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "SpuntoCppLedUnit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SpuntoLedComponent"
#pragma resource "*.dfm"
TSpuntoLedDelphitoCPPApplication *SpuntoLedDelphitoCPPApplication;
//---------------------------------------------------------------------------
__fastcall TSpuntoLedDelphitoCPPApplication::TSpuntoLedDelphitoCPPApplication(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TSpuntoLedDelphitoCPPApplication::Exit1Click(TObject *Sender)
{
   Close();         //Exits the Application
}
//---------------------------------------------------------------------------

void __fastcall TSpuntoLedDelphitoCPPApplication::ONColor1Click(TObject *Sender)
{
 if (ColorDialog1->Execute())               // LED ON COLOR
 SpuntoLed1->SpuntoLedOnColor = ColorDialog1->Color;
 SpuntoBigLed->SpuntoLedOnColor = ColorDialog1->Color;
 SpuntoLed1->LedOn();
}
//---------------------------------------------------------------------------

void __fastcall TSpuntoLedDelphitoCPPApplication::OFFColor1Click(TObject *Sender)
{
 if (ColorDialog1->Execute())               // LED OFF COLOR
 SpuntoLed2->SpuntoLedOffColor = ColorDialog1->Color;
 SpuntoBigLed->SpuntoLedOffColor = ColorDialog1->Color;
 SpuntoLed2->LedOff();
}
//---------------------------------------------------------------------------

void __fastcall TSpuntoLedDelphitoCPPApplication::FormCreate(TObject *Sender)
{
  SpuntoLed1->LedOn();                      // LED SETUP
  SpuntoLed2->LedOff();                     // AT FORM CREATION
  SpuntoBigLed->Shape= stRoundRect;
}
//---------------------------------------------------------------------------


void __fastcall TSpuntoLedDelphitoCPPApplication::SpuntoBigLedMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   SpuntoBigLed->LedOn();                   // BIG LED ON WHEN MOUSE MOVE
}
//---------------------------------------------------------------------------

void __fastcall TSpuntoLedDelphitoCPPApplication::FormMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   SpuntoBigLed->LedOff();                  // BIG LED OFF WHEN OUTSIDE
}                                           // LED AREA
//---------------------------------------------------------------------------


void __fastcall TSpuntoLedDelphitoCPPApplication::RadioButtonSquareClick(
      TObject *Sender)
{
   SpuntoBigLed->Shape= stRoundRect;        // LED SHAPE ROUND RECT
}
//---------------------------------------------------------------------------

void __fastcall TSpuntoLedDelphitoCPPApplication::RadioButtonRoundClick(
      TObject *Sender)
{
   SpuntoBigLed->Shape= stCircle;           // LED SHAPE CIRCLE
}
//---------------------------------------------------------------------------


