class Vettore2D {

  public int i;
  public int j;
  
  public Vettore2D(int ci, int cj) {
    i = ci;
    j = cj;
  }

  public static bool operator ==(Vettore2D a, Vettore2D b) {
    return ((a.i == b.i) && (a.j == b.j));
  }

  public static bool operator !=(Vettore2D a, Vettore2D b) {
    return !(a == b);
  }

  public override bool Equals(object o) {
    return (this == (Vettore2D)o);
  }

  public override int GetHashCode() {
    return i + j;
  }

  public double CalcolaMisura() {
    return System.Math.Sqrt((i * i) + (j * j));
  }

  public static bool operator >(Vettore2D a, Vettore2D b) {
    return (a.CalcolaMisura() > b.CalcolaMisura());
  }

  public static bool operator <(Vettore2D a, Vettore2D b) {
    return (a.CalcolaMisura() < b.CalcolaMisura());
  }

  public static bool operator >=(Vettore2D a, Vettore2D b) {
    return (a.CalcolaMisura() >= b.CalcolaMisura());
  }

  public static bool operator <=(Vettore2D a, Vettore2D b) {
    return (a.CalcolaMisura() <= b.CalcolaMisura());
  }

}

